<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: src/Transform.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_transform_8hpp_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Transform.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_transform_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * eduRayTracer - An Educational Ray Tracing Software Package</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * Contributor(s): Pedro Santana - ISCTE-IUL (2014-2016)</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#ifndef _H_Transform_</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#define _H_Transform_</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="keyword">class </span><a class="code" href="class_camera.html">Camera</a>;</div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;</div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_mat_8hpp.html">Mat.hpp</a>&quot;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_camera_8hpp.html">Camera.hpp</a>&quot;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00017"></a><span class="lineno"><a class="line" href="class_transform.html">   17</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_transform.html">Transform</a> {</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keyword">protected</span>:</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;</div><div class="line"><a name="l00022"></a><span class="lineno"><a class="line" href="class_transform.html#a18ae73009c329f5444145e0fb9a5f286">   22</a></span>&#160;    std::vector&lt;Transform*&gt; <a class="code" href="class_transform.html#a18ae73009c329f5444145e0fb9a5f286">childs</a>;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00026"></a><span class="lineno"><a class="line" href="class_transform.html#a66ac17fab8f59fa9b26ac109b16f6bf0">   26</a></span>&#160;    <a class="code" href="class_mat.html">Mat</a> <a class="code" href="class_transform.html#a66ac17fab8f59fa9b26ac109b16f6bf0">local_tf</a>;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno"><a class="line" href="class_transform.html#afa608ba2e982f79002af1a1d674871f4">   30</a></span>&#160;    <a class="code" href="class_mat.html">Mat</a> <a class="code" href="class_transform.html#afa608ba2e982f79002af1a1d674871f4">global_tf</a>;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno"><a class="line" href="class_transform.html#ac0b7b583f8c67c59c85a3d38d623a010">   33</a></span>&#160;    <a class="code" href="class_mat.html">Mat</a> <a class="code" href="class_transform.html#ac0b7b583f8c67c59c85a3d38d623a010">global_tf_inv</a>;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00038"></a><span class="lineno"><a class="line" href="class_transform.html#a9460cedd048ae3d6a8e0680f36638600">   38</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="class_transform.html#a9460cedd048ae3d6a8e0680f36638600">id</a>;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00041"></a><span class="lineno"><a class="line" href="class_transform.html#aa08ca4266efabc768973cdeea51945ab">   41</a></span>&#160;    <a class="code" href="class_transform.html#aa08ca4266efabc768973cdeea51945ab">Transform</a>() {}</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00047"></a><span class="lineno"><a class="line" href="class_transform.html#a13428997892b461d999ca0d75d01ab34">   47</a></span>&#160;    <a class="code" href="class_transform.html#a13428997892b461d999ca0d75d01ab34">Transform</a>(<span class="keywordtype">int</span> _id) : id(_id) {}</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <a class="code" href="class_transform.html#aa08ca4266efabc768973cdeea51945ab">Transform</a>(<a class="code" href="class_mat.html">Mat</a> _m, <span class="keywordtype">int</span> _id);</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    <a class="code" href="class_transform.html#aa08ca4266efabc768973cdeea51945ab">Transform</a>(<span class="keywordtype">double</span> yaw, <span class="keywordtype">double</span> pitch, <span class="keywordtype">double</span> roll, <span class="keywordtype">double</span> dx, <span class="keywordtype">double</span> dy, <span class="keywordtype">double</span> dz, </div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;              <span class="keywordtype">double</span> scale_x, <span class="keywordtype">double</span> scale_y, <span class="keywordtype">double</span> scale_z, <span class="keywordtype">int</span> _id);</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    </div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    </div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div><div class="line"><a name="l00079"></a><span class="lineno"><a class="line" href="class_transform.html#af68f2847da11a453652c9eda3c1e6f38">   79</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_transform.html#af68f2847da11a453652c9eda3c1e6f38">setMat</a>(<a class="code" href="class_mat.html">Mat</a> _mat){ local_tf = _mat; global_tf = <a class="code" href="class_transform.html#a66ac17fab8f59fa9b26ac109b16f6bf0">local_tf</a>; <a class="code" href="class_transform.html#a0d6254a919a5a6f8f66b20b5849da99e">update_global_tf</a>();}</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    </div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div><div class="line"><a name="l00085"></a><span class="lineno"><a class="line" href="class_transform.html#a2277bcdd410169374f66d55a5892c602">   85</a></span>&#160;    <a class="code" href="class_mat.html">Mat</a> <a class="code" href="class_transform.html#a2277bcdd410169374f66d55a5892c602">getMat</a>(){ <span class="keywordflow">return</span> <a class="code" href="class_transform.html#a66ac17fab8f59fa9b26ac109b16f6bf0">local_tf</a>;}</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    </div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div><div class="line"><a name="l00091"></a><span class="lineno"><a class="line" href="class_transform.html#a44bcd8141337e772ab0dadaf4d70dc01">   91</a></span>&#160;    <a class="code" href="class_mat.html">Mat</a> <a class="code" href="class_transform.html#a44bcd8141337e772ab0dadaf4d70dc01">getGlobalMat</a>(){ <span class="keywordflow">return</span> <a class="code" href="class_transform.html#afa608ba2e982f79002af1a1d674871f4">global_tf</a>;}</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div><div class="line"><a name="l00097"></a><span class="lineno"><a class="line" href="class_transform.html#a85f2c4d2e9e37998ef96308b33cc1e05">   97</a></span>&#160;    <a class="code" href="class_mat.html">Mat</a> <a class="code" href="class_transform.html#a85f2c4d2e9e37998ef96308b33cc1e05">getGlobalMatInv</a>(){ <span class="keywordflow">return</span> <a class="code" href="class_transform.html#ac0b7b583f8c67c59c85a3d38d623a010">global_tf_inv</a>;}</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_transform.html#a6d505ddbe3c2e9df2c3e42dd2630476f">addChild</a>(<a class="code" href="class_transform.html">Transform</a>* _tf);</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;</div><div class="line"><a name="l00111"></a><span class="lineno"><a class="line" href="class_transform.html#a0feb936d19fbc6a699dec3714ef0af02">  111</a></span>&#160;    <a class="code" href="class_transform.html">Transform</a>* <a class="code" href="class_transform.html#a0feb936d19fbc6a699dec3714ef0af02">getChild</a>(<span class="keywordtype">int</span> _i) {<span class="keywordflow">return</span> childs[_i];};</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_transform.html#a5e79111567be939ecd8ef89f38c9c637">update_local_tf</a>(<span class="keywordtype">double</span> yaw, <span class="keywordtype">double</span> pitch, <span class="keywordtype">double</span> roll, <span class="keywordtype">double</span> dx, <span class="keywordtype">double</span> dy, <span class="keywordtype">double</span> dz, </div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;                    <span class="keywordtype">double</span> scale_x, <span class="keywordtype">double</span> scale_y, <span class="keywordtype">double</span> scale_z);</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;              </div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="class_transform.html#a0d6254a919a5a6f8f66b20b5849da99e">update_global_tf</a>();</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="class_transform.html#a0d6254a919a5a6f8f66b20b5849da99e">update_global_tf</a>(<a class="code" href="class_mat.html">Mat</a> &amp;current);</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;};</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="class_transform_html_a85f2c4d2e9e37998ef96308b33cc1e05"><div class="ttname"><a href="class_transform.html#a85f2c4d2e9e37998ef96308b33cc1e05">Transform::getGlobalMatInv</a></div><div class="ttdeci">Mat getGlobalMatInv()</div><div class="ttdoc">Returns the inverted global matrix (for normals transformation). </div><div class="ttdef"><b>Definition:</b> Transform.hpp:97</div></div>
<div class="ttc" id="class_mat_html"><div class="ttname"><a href="class_mat.html">Mat</a></div><div class="ttdoc">A class to create and manipulate matrices. </div><div class="ttdef"><b>Definition:</b> Mat.hpp:13</div></div>
<div class="ttc" id="class_transform_html_a9460cedd048ae3d6a8e0680f36638600"><div class="ttname"><a href="class_transform.html#a9460cedd048ae3d6a8e0680f36638600">Transform::id</a></div><div class="ttdeci">int id</div><div class="ttdoc">The id of this transform. </div><div class="ttdef"><b>Definition:</b> Transform.hpp:38</div></div>
<div class="ttc" id="class_camera_html"><div class="ttname"><a href="class_camera.html">Camera</a></div><div class="ttdoc">A class to create and manipulate virtual projective cameras. </div><div class="ttdef"><b>Definition:</b> Camera.hpp:20</div></div>
<div class="ttc" id="class_transform_html_a0d6254a919a5a6f8f66b20b5849da99e"><div class="ttname"><a href="class_transform.html#a0d6254a919a5a6f8f66b20b5849da99e">Transform::update_global_tf</a></div><div class="ttdeci">virtual void update_global_tf()</div><div class="ttdoc">Triggers the recursive update of the global_tf transformation matrices of all Transform objects that ...</div><div class="ttdef"><b>Definition:</b> Transform.cpp:35</div></div>
<div class="ttc" id="class_transform_html_a5e79111567be939ecd8ef89f38c9c637"><div class="ttname"><a href="class_transform.html#a5e79111567be939ecd8ef89f38c9c637">Transform::update_local_tf</a></div><div class="ttdeci">void update_local_tf(double yaw, double pitch, double roll, double dx, double dy, double dz, double scale_x, double scale_y, double scale_z)</div><div class="ttdef"><b>Definition:</b> Transform.cpp:29</div></div>
<div class="ttc" id="class_transform_html"><div class="ttname"><a href="class_transform.html">Transform</a></div><div class="ttdoc">A class to handle rigid transformations. </div><div class="ttdef"><b>Definition:</b> Transform.hpp:17</div></div>
<div class="ttc" id="class_transform_html_a13428997892b461d999ca0d75d01ab34"><div class="ttname"><a href="class_transform.html#a13428997892b461d999ca0d75d01ab34">Transform::Transform</a></div><div class="ttdeci">Transform(int _id)</div><div class="ttdoc">A Transform constructor. Applying this Transform without further updates generates undefined behaviou...</div><div class="ttdef"><b>Definition:</b> Transform.hpp:47</div></div>
<div class="ttc" id="class_transform_html_a2277bcdd410169374f66d55a5892c602"><div class="ttname"><a href="class_transform.html#a2277bcdd410169374f66d55a5892c602">Transform::getMat</a></div><div class="ttdeci">Mat getMat()</div><div class="ttdoc">Returns the matrix (Mat) associated to this Transform (local_tf). </div><div class="ttdef"><b>Definition:</b> Transform.hpp:85</div></div>
<div class="ttc" id="class_transform_html_a6d505ddbe3c2e9df2c3e42dd2630476f"><div class="ttname"><a href="class_transform.html#a6d505ddbe3c2e9df2c3e42dd2630476f">Transform::addChild</a></div><div class="ttdeci">void addChild(Transform *_tf)</div><div class="ttdoc">Adds a given transform as a child of this transform. </div><div class="ttdef"><b>Definition:</b> Transform.cpp:24</div></div>
<div class="ttc" id="class_transform_html_aa08ca4266efabc768973cdeea51945ab"><div class="ttname"><a href="class_transform.html#aa08ca4266efabc768973cdeea51945ab">Transform::Transform</a></div><div class="ttdeci">Transform()</div><div class="ttdoc">A Transform constructor which does nothing. </div><div class="ttdef"><b>Definition:</b> Transform.hpp:41</div></div>
<div class="ttc" id="class_transform_html_a18ae73009c329f5444145e0fb9a5f286"><div class="ttname"><a href="class_transform.html#a18ae73009c329f5444145e0fb9a5f286">Transform::childs</a></div><div class="ttdeci">std::vector&lt; Transform * &gt; childs</div><div class="ttdoc">A Vector of pointers to the set of Transform objects that are hierarchically below this Transform...</div><div class="ttdef"><b>Definition:</b> Transform.hpp:22</div></div>
<div class="ttc" id="class_transform_html_a44bcd8141337e772ab0dadaf4d70dc01"><div class="ttname"><a href="class_transform.html#a44bcd8141337e772ab0dadaf4d70dc01">Transform::getGlobalMat</a></div><div class="ttdeci">Mat getGlobalMat()</div><div class="ttdoc">Returns the global matrix (Mat) that is obtained by multiplying all transformations along the hierarc...</div><div class="ttdef"><b>Definition:</b> Transform.hpp:91</div></div>
<div class="ttc" id="class_transform_html_afa608ba2e982f79002af1a1d674871f4"><div class="ttname"><a href="class_transform.html#afa608ba2e982f79002af1a1d674871f4">Transform::global_tf</a></div><div class="ttdeci">Mat global_tf</div><div class="ttdef"><b>Definition:</b> Transform.hpp:30</div></div>
<div class="ttc" id="class_transform_html_ac0b7b583f8c67c59c85a3d38d623a010"><div class="ttname"><a href="class_transform.html#ac0b7b583f8c67c59c85a3d38d623a010">Transform::global_tf_inv</a></div><div class="ttdeci">Mat global_tf_inv</div><div class="ttdoc">Inverted global_tf. </div><div class="ttdef"><b>Definition:</b> Transform.hpp:33</div></div>
<div class="ttc" id="class_transform_html_a0feb936d19fbc6a699dec3714ef0af02"><div class="ttname"><a href="class_transform.html#a0feb936d19fbc6a699dec3714ef0af02">Transform::getChild</a></div><div class="ttdeci">Transform * getChild(int _i)</div><div class="ttdef"><b>Definition:</b> Transform.hpp:111</div></div>
<div class="ttc" id="_mat_8hpp_html"><div class="ttname"><a href="_mat_8hpp.html">Mat.hpp</a></div></div>
<div class="ttc" id="class_transform_html_a66ac17fab8f59fa9b26ac109b16f6bf0"><div class="ttname"><a href="class_transform.html#a66ac17fab8f59fa9b26ac109b16f6bf0">Transform::local_tf</a></div><div class="ttdeci">Mat local_tf</div><div class="ttdef"><b>Definition:</b> Transform.hpp:26</div></div>
<div class="ttc" id="class_transform_html_af68f2847da11a453652c9eda3c1e6f38"><div class="ttname"><a href="class_transform.html#af68f2847da11a453652c9eda3c1e6f38">Transform::setMat</a></div><div class="ttdeci">void setMat(Mat _mat)</div><div class="ttdoc">Sets the matrix (Mat) associated to this Transform. </div><div class="ttdef"><b>Definition:</b> Transform.hpp:79</div></div>
<div class="ttc" id="_camera_8hpp_html"><div class="ttname"><a href="_camera_8hpp.html">Camera.hpp</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="_transform_8hpp.html">Transform.hpp</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
